Index: trunk/src/kash/Makefile
===================================================================
--- trunk/src/kash/Makefile	(revision 1232)
+++ 	(revision )
@@ -1,79 +1,0 @@
-#	$NetBSD: Makefile,v 1.80 2005/06/26 19:10:49 christos Exp $
-#	@(#)Makefile	8.4 (Berkeley) 5/5/95
-
-.include <bsd.own.mk>
-
-YHEADER=1
-PROG=	sh
-SHSRCS=	alias.c cd.c echo.c error.c eval.c exec.c expand.c \
-	histedit.c input.c jobs.c mail.c main.c memalloc.c miscbltin.c \
-	mystring.c options.c parser.c redir.c show.c trap.c output.c var.c \
-	test.c kill.c syntax.c
-GENSRCS=arith.c arith_lex.c builtins.c init.c nodes.c
-GENHDRS=arith.h builtins.h nodes.h token.h
-SRCS=	${SHSRCS} ${GENSRCS}
-
-DPSRCS+=${GENHDRS}
-
-LDADD+=	-ll -ledit -ltermcap
-DPADD+=	${LIBL} ${LIBEDIT} ${LIBTERMCAP}
-
-LFLAGS=	-8	# 8-bit lex scanner for arithmetic
-YFLAGS=	-d
-
-# The .depend file can get references to these temporary files
-.OPTIONAL: lex.yy.c y.tab.c
-
-.ifdef CRUNCHEDPROG
-LFLAGS+=-L
-YFLAGS+=-l
-.endif
-
-CPPFLAGS+=-DSHELL -I. -I${.CURDIR}
-#XXX: For testing only.
-#CPPFLAGS+=-DDEBUG=1
-#CFLAGS+=-funsigned-char
-#TARGET_CHARFLAG?= -DTARGET_CHAR="unsigned char" -funsigned-char
-
-.ifdef SMALLPROG
-CPPFLAGS+=-DSMALL
-.else
-SRCS+=printf.c
-.endif
-
-.PATH:	${.CURDIR}/bltin ${NETBSDSRCDIR}/bin/test \
-	${NETBSDSRCDIR}/usr.bin/printf \
-	${NETBSDSRCDIR}/bin/kill
-
-CLEANFILES+= ${GENSRCS} ${GENHDRS} y.tab.h
-CLEANFILES+= trace
-
-token.h: mktokens
-	${_MKTARGET_CREATE}
-	${HOST_SH} ${.ALLSRC}
-
-builtins.h: builtins.c
-	${_MKTARGET_CREATE}
-
-builtins.c: mkbuiltins shell.h builtins.def
-	${_MKTARGET_CREATE}
-	${HOST_SH} ${.ALLSRC} ${.OBJDIR}
-	[ -f builtins.h ]
-
-init.c: mkinit.sh ${SHSRCS}
-	${_MKTARGET_CREATE}
-	${HOST_SH} ${.ALLSRC}
-
-nodes.h: nodes.c
-
-nodes.c: mknodes.sh nodetypes nodes.c.pat
-	${_MKTARGET_CREATE}
-	${HOST_SH} ${.ALLSRC} ${.OBJDIR}
-	[ -f nodes.h ]
-
-.if ${USETOOLS} == "yes"
-COMPATOBJDIR!=	cd ${NETBSDSRCDIR}/tools/compat && ${PRINTOBJDIR}
-NBCOMPATLIB=	-L${COMPATOBJDIR} -lnbcompat
-.endif
-
-.include <bsd.prog.mk>
Index: trunk/src/kash/generated/arith.c
===================================================================
--- trunk/src/kash/generated/arith.c	(revision 1232)
+++ trunk/src/kash/generated/arith.c	(revision 1233)
@@ -1,5 +1,5 @@
 #ifndef lint
 /*static char yysccsid[] = "from: @(#)yaccpar	1.9 (Berkeley) 02/21/93";*/
-static char yyrcsid[] = "$Id: skeleton.c,v 1.2 1997/06/23 02:51:17 tdukes Exp $";
+static char yyrcsid[] = "$Id$";
 #endif
 #define YYBYACC 1
Index: trunk/src/kash/shfile.c
===================================================================
--- trunk/src/kash/shfile.c	(revision 1232)
+++ trunk/src/kash/shfile.c	(revision 1233)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: trunk/src/kash/shfile.h
===================================================================
--- trunk/src/kash/shfile.h	(revision 1232)
+++ trunk/src/kash/shfile.h	(revision 1233)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: trunk/src/kash/shinstance.c
===================================================================
--- trunk/src/kash/shinstance.c	(revision 1232)
+++ trunk/src/kash/shinstance.c	(revision 1233)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: trunk/src/kash/shinstance.h
===================================================================
--- trunk/src/kash/shinstance.h	(revision 1232)
+++ trunk/src/kash/shinstance.h	(revision 1233)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: trunk/src/kash/shthread.c
===================================================================
--- trunk/src/kash/shthread.c	(revision 1232)
+++ trunk/src/kash/shthread.c	(revision 1233)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: trunk/src/kash/shthread.h
===================================================================
--- trunk/src/kash/shthread.h	(revision 1232)
+++ trunk/src/kash/shthread.h	(revision 1233)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: trunk/src/kash/shtypes.h
===================================================================
--- trunk/src/kash/shtypes.h	(revision 1232)
+++ trunk/src/kash/shtypes.h	(revision 1233)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *